commit c08ae0cf33e7e8339456a4a9ba0c494600eadcf3
Author: Uros Bizjak <ubizjak@gmail.com>
Date:   Fri Dec 6 16:59:16 2024 +0100

    i386: Fix unwanted fwprop to 3dNOW! insn [PR117926]
    
    The compiler is able to forward propagate a partial vector V4SF instruction
    using XMM registers to a 3dNOW! V2SF instruction using MM registers.  Prevent
    unwanted transformation by tagging 3dNOW! V2SF instructions using generic
    RTXes with "(unspec [(const_int 0)] UNSPEC_3DNOW)" tag.
    
            PR target/117926
    
    gcc/ChangeLog:
    
            * config/i386/mmx.md (UNSPEC_3DNOW): New unspec.
            (mmx_addv2sf3): Tag insn with UNSPEC_3DNOW tag.
            (*mmx_addv2sf3): Ditto.
            (mmx_sub2vsf3): Ditto.
            (mmx_subrv2sf3): Ditto.
            (*mmx_subv2sf3): Ditto.
            (mmx_mulv2sf3): Ditto.
            (mmx_<smaxmin:code>v2sf3): Ditto.
            (*mmx_<smaxmin:code>v2sf3): Ditto.
            (mmx_ieee_<ieee_maxmin>v2sf3): Ditto.
            (mmx_eqv2sf3): Ditto.
            (*mmx_eqv2sf3): Ditto.
            (mmx_gtv2sf3): Ditto.
            (mmx_gev2sf3): Ditto.
            (mmx_fix_truncv2sfv2si2): Ditto.
            (mmx_floatv2siv2sf2): Ditto.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/i386/pr117926.c: New test.
    
    (cherry picked from commit 1acc5cffbb04949a790d6e1a34a46ec71418a57b)

diff --git a/gcc/testsuite/gcc.target/i386/pr117926.c b/gcc/testsuite/gcc.target/i386/pr117926.c
new file mode 100644
index 00000000000..6b7aca3726d
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr117926.c
@@ -0,0 +1,18 @@
+/* PR target/117926 */
+/* { dg-do compile { target { ! ia32 } } } */
+/* { dg-options "-O2 -m3dnow" } */
+
+struct s
+{
+  int i[2];
+  float f[2];
+  double d;
+};
+
+void f (struct s *s)
+{
+  s->f[0] = s->i[0];
+  s->f[1] = s->i[1];
+}
+
+/* { dg-final { scan-assembler-not "pi2fd" } } */

